-- --------------------------------------------------------
-- Host:                         192.168.1.201
-- Server version:               10.5.16-MariaDB-log - MariaDB Server
-- Server OS:                    Linux
-- HeidiSQL Version:             11.3.0.6295
-- --------------------------------------------------------

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET NAMES utf8 */;
/*!50503 SET NAMES utf8mb4 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

-- Dumping structure for table onlinelog.access_rights
CREATE TABLE IF NOT EXISTS `access_rights` (
  `right` int(11) NOT NULL,
  `begin_date` datetime NOT NULL DEFAULT '1970-01-01 00:00:00',
  `end_date` datetime NOT NULL DEFAULT '1970-01-01 00:00:00',
  `monday_begin` time NOT NULL DEFAULT '00:00:00',
  `monday_end` time NOT NULL DEFAULT '00:00:00',
  `tuesday_begin` time NOT NULL DEFAULT '00:00:00',
  `tuesday_end` time NOT NULL DEFAULT '00:00:00',
  `wednesday_begin` time NOT NULL DEFAULT '00:00:00',
  `wednesday_end` time NOT NULL DEFAULT '00:00:00',
  `thursday_begin` time NOT NULL DEFAULT '00:00:00',
  `thursday_end` time NOT NULL DEFAULT '00:00:00',
  `friday_begin` time NOT NULL DEFAULT '00:00:00',
  `friday_end` time NOT NULL DEFAULT '00:00:00',
  `saturday_begin` time NOT NULL DEFAULT '00:00:00',
  `saturday_end` time NOT NULL DEFAULT '00:00:00',
  `sunday_begin` time NOT NULL DEFAULT '00:00:00',
  `sunday_end` time NOT NULL DEFAULT '00:00:00',
  `timeout` int(11) NOT NULL DEFAULT 0,
  `counter` int(1) NOT NULL DEFAULT 0,
  PRIMARY KEY (`right`,`begin_date`,`end_date`,`monday_begin`,`monday_end`,`tuesday_begin`,`tuesday_end`,`wednesday_begin`,`wednesday_end`,`thursday_begin`,`thursday_end`,`friday_begin`,`friday_end`,`saturday_begin`,`saturday_end`,`sunday_begin`,`sunday_end`,`timeout`,`counter`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- Data exporting was unselected.

-- Dumping structure for table onlinelog.card_types
CREATE TABLE IF NOT EXISTS `card_types` (
  `type` int(11) NOT NULL,
  `description` text NOT NULL,
  `color` varchar(6) NOT NULL DEFAULT 'FFFFFF',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- Data exporting was unselected.

-- Dumping structure for table onlinelog.debug_log
CREATE TABLE IF NOT EXISTS `debug_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `osn` varchar(50) DEFAULT NULL,
  `log` longtext NOT NULL,
  `time` datetime DEFAULT current_timestamp(),
  `direction` enum('FROM_READER','FROM_SERVER') DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `time` (`time`)
) ENGINE=MyISAM AUTO_INCREMENT=20393982 DEFAULT CHARSET=utf8;

-- Data exporting was unselected.

-- Dumping structure for table onlinelog.events
CREATE TABLE IF NOT EXISTS `events` (
  `id` int(11) NOT NULL,
  `uid` varchar(50) NOT NULL DEFAULT '',
  `pid` int(11) DEFAULT NULL,
  `time` datetime NOT NULL,
  `delta` int(11) NOT NULL,
  `type` int(11) NOT NULL,
  `state` int(11) NOT NULL DEFAULT 0,
  `status` int(11) NOT NULL,
  `osn` varchar(20) NOT NULL,
  `sn1` varchar(20) NOT NULL,
  `sn2` varchar(20) DEFAULT NULL,
  `reader` int(11) NOT NULL,
  `rte` int(11) NOT NULL,
  `note` varchar(50) DEFAULT '',
  `last_access` datetime DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`id`,`osn`,`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;

-- Data exporting was unselected.

-- Dumping structure for table onlinelog.readers
CREATE TABLE IF NOT EXISTS `readers` (
  `osn` varchar(50) NOT NULL,
  `descriptor` longtext DEFAULT NULL,
  `whitelist_on_server` timestamp NULL DEFAULT NULL,
  `whitelist_in_reader` timestamp NULL DEFAULT NULL,
  `blacklist_on_server` timestamp NULL DEFAULT NULL,
  `blacklist_in_reader` timestamp NULL DEFAULT NULL,
  `types_on_server` timestamp NULL DEFAULT NULL,
  `types_in_reader` timestamp NULL DEFAULT NULL,
  `rights_on_server` timestamp NULL DEFAULT NULL,
  `rights_in_reader` timestamp NULL DEFAULT NULL,
  `last_seen` timestamp NULL DEFAULT NULL,
  `ip` varchar(50) DEFAULT NULL,
  `online_firmware` varchar(50) DEFAULT NULL,
  `reader1_firmware` varchar(50) DEFAULT NULL,
  `reader2_firmware` varchar(50) DEFAULT NULL,
  `requested_online_firmware` varchar(50) DEFAULT NULL,
  `requested_reader1_firmware` varchar(50) DEFAULT NULL,
  `requested_reader2_firmware` varchar(50) DEFAULT NULL,
  `max_id` int(11) DEFAULT 0,
  `last_id` int(11) DEFAULT 0,
  `valid_id` enum('LAST','MAX') DEFAULT 'LAST',
  PRIMARY KEY (`osn`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;

-- Data exporting was unselected.

-- Dumping structure for table onlinelog.users
CREATE TABLE IF NOT EXISTS `users` (
  `uid` varchar(50) NOT NULL,
  `pid` int(11) DEFAULT NULL,
  `type` int(11) NOT NULL DEFAULT 1,
  `description` varchar(50) DEFAULT NULL,
  `image` longblob DEFAULT NULL,
  `access_right` int(11) DEFAULT NULL,
  PRIMARY KEY (`uid`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- Data exporting was unselected.

-- Dumping structure for trigger onlinelog.access_rights_after_delete
SET @OLDTMP_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_ENGINE_SUBSTITUTION';
DELIMITER //
CREATE TRIGGER `access_rights_after_delete` AFTER DELETE ON `access_rights` FOR EACH ROW BEGIN
UPDATE readers SET readers.rights_on_server=NOW();
END//
DELIMITER ;
SET SQL_MODE=@OLDTMP_SQL_MODE;

-- Dumping structure for trigger onlinelog.access_rights_after_insert
SET @OLDTMP_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_ENGINE_SUBSTITUTION';
DELIMITER //
CREATE TRIGGER `access_rights_after_insert` AFTER INSERT ON `access_rights` FOR EACH ROW BEGIN
UPDATE readers SET readers.rights_on_server=NOW();
END//
DELIMITER ;
SET SQL_MODE=@OLDTMP_SQL_MODE;

-- Dumping structure for trigger onlinelog.access_rights_after_update
SET @OLDTMP_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_ENGINE_SUBSTITUTION';
DELIMITER //
CREATE TRIGGER `access_rights_after_update` AFTER UPDATE ON `access_rights` FOR EACH ROW BEGIN
UPDATE readers SET readers.rights_on_server=NOW();
END//
DELIMITER ;
SET SQL_MODE=@OLDTMP_SQL_MODE;

-- Dumping structure for trigger onlinelog.card_types_after_delete
SET @OLDTMP_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_ENGINE_SUBSTITUTION';
DELIMITER //
CREATE TRIGGER `card_types_after_delete` AFTER DELETE ON `card_types` FOR EACH ROW BEGIN
UPDATE readers SET readers.types_on_server=NOW();
END//
DELIMITER ;
SET SQL_MODE=@OLDTMP_SQL_MODE;

-- Dumping structure for trigger onlinelog.card_types_after_insert
SET @OLDTMP_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_ENGINE_SUBSTITUTION';
DELIMITER //
CREATE TRIGGER `card_types_after_insert` AFTER INSERT ON `card_types` FOR EACH ROW BEGIN
UPDATE readers SET readers.types_on_server=NOW();
END//
DELIMITER ;
SET SQL_MODE=@OLDTMP_SQL_MODE;

-- Dumping structure for trigger onlinelog.card_types_after_update
SET @OLDTMP_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_ENGINE_SUBSTITUTION';
DELIMITER //
CREATE TRIGGER `card_types_after_update` AFTER UPDATE ON `card_types` FOR EACH ROW BEGIN
UPDATE readers SET readers.types_on_server=NOW();
END//
DELIMITER ;
SET SQL_MODE=@OLDTMP_SQL_MODE;

-- Dumping structure for trigger onlinelog.events_after_insert
SET @OLDTMP_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_ENGINE_SUBSTITUTION';
DELIMITER //
CREATE TRIGGER `events_after_insert` AFTER INSERT ON `events` FOR EACH ROW BEGIN
INSERT INTO users (uid, pid) VALUES(NEW.uid, NEW.pid) ON DUPLICATE KEY UPDATE uid=NEW.uid;
INSERT INTO readers (osn) VALUES(NEW.osn) ON DUPLICATE KEY UPDATE osn=NEW.osn;
END//
DELIMITER ;
SET SQL_MODE=@OLDTMP_SQL_MODE;

-- Dumping structure for trigger onlinelog.users_after_update
SET @OLDTMP_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_ENGINE_SUBSTITUTION';
DELIMITER //
CREATE TRIGGER `users_after_update` AFTER UPDATE ON `users` FOR EACH ROW BEGIN
UPDATE readers SET readers.whitelist_on_server=NOW();
UPDATE readers SET readers.blacklist_on_server=NOW();
UPDATE readers SET readers.types_on_server=NOW();
UPDATE readers SET readers.rights_on_server=NOW();
END//
DELIMITER ;
SET SQL_MODE=@OLDTMP_SQL_MODE;

/*!40101 SET SQL_MODE=IFNULL(@OLD_SQL_MODE, '') */;
/*!40014 SET FOREIGN_KEY_CHECKS=IFNULL(@OLD_FOREIGN_KEY_CHECKS, 1) */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40111 SET SQL_NOTES=IFNULL(@OLD_SQL_NOTES, 1) */;
