<?php
header("Access-Control-Allow-Origin: *");
define('DEBUG_LOG', true);

//ENABLE OR DISABLE TNA COMPATIBILITY LAYER.
define('TNA', false);
define('TNA_URL', "");

$db = parse_ini_file("db_config.ini");
$servername = $db['servername'];
$username = $db['username'];
$password = $db['password'];
$dbname = $db['dbname'];
date_default_timezone_set('UTC');

$table = "events";

if (isset($_GET["osn"])) {

    read_log($_GET["osn"]);

    exit();
}

$post = file_get_contents('php://input');

if (DEBUG_LOG) {
    insert_debug_log($post, "FROM_READER");
}

$data = json_decode($post, true);

if (isset($data["blacklist_timestamp"]) && !isset($data["rte"])) {
    echo_params($data);
}

if (isset($data["rte"])) {
    parse_log($data["rte"], 1);
    echo_params($data);
}

if (isset($data["log"])) {
    parse_log($data["log"], 0);
}

function right_is_valid($array, $right)
{
    foreach ($array as $value) {
        $str_arr = explode(",", $value);
        if ($str_arr[0] == $right) {
            return true;
        }
    }

    return false;
}

function echo_params($data)
{
    $output = "";
    $headers = apache_request_headers();
    $headersUpper = array_change_key_case($headers, CASE_UPPER);
    $osn = $headersUpper["OSN"];
    $readerIP = $headersUpper["IP"];
    $readerFW = $headersUpper["FW"];
    $readerFW1 = $headersUpper["FW1"];
    $readerFW2 = $headersUpper["FW2"];
    global $servername, $username, $password, $dbname;
    $last_log_id = 0;
    $last_rte_id = -1;
    $blacklist = null;
    $whitelist = null;
    $types_list = array();
    $types_color = array();
    $types_output = null;
    $available_access_rights = array();
    $access_rights_list = array();
    $access_rights_output = null;

    $calculated_max_id = 0;
    $current_last_id = 0;
    $current_max_id = 0;

    $last_valid_id = 0;

	
	if(isset($data["whitelist_timestamp"]))
	{
	   $wl_ts = $data["whitelist_timestamp"];
	}
	else
	{
		$wl_ts = 0;
	}
	
	if(isset($data["blacklist_timestamp"]))
	{
	   $bl_ts = $data["blacklist_timestamp"];
	}
	else
	{
		$bl_ts = 0;
	}
	
	if(isset($data["types_timestamp"]))
	{
	   $types_ts = $data["types_timestamp"];
	}
	else
	{
		$types_ts = 0;
	}

	if(isset($data["rights_timestamp"]))
	{
	   $access_rights_ts = $data["rights_timestamp"];
	}
	else
	{
		$access_rights_ts = 0;
	}
    $wl_ts_local = 0;
    $bl_ts_local = 0;
    $types_ts_local = 0;
    $access_rights_ts_local = 0;
    $requested_fw = null;
    $requested_fw1 = null;
    $requested_fw2 = null;
    $update_fw = "";

    $conn = mysqli_connect($servername, $username, $password, $dbname);

    if (!$conn) {
        die("Connection failed: " . mysqli_connect_error());
    }

    $sql = "SELECT temp_tbl.id AS id from (SELECT id, rte FROM events WHERE osn='$osn' GROUP BY id HAVING COUNT(id) = (SELECT MAX(tbl.cnt_id) AS maximum FROM (SELECT COUNT(id) AS cnt_id  FROM events WHERE osn='$osn' GROUP BY id) AS tbl)) AS temp_tbl WHERE temp_tbl.rte=0 ORDER BY temp_tbl.id DESC LIMIT 1";
    $result = $conn->query($sql);

    if ($result->num_rows > 0) {
        while ($row = $result->fetch_assoc()) {
            $last_log_id = $row["id"];
            break;
        }
    }

    $sql = "SELECT temp_tbl.id AS id from (SELECT id, rte FROM events WHERE osn='$osn' GROUP BY id HAVING COUNT(id) = (SELECT MAX(tbl.cnt_id) AS maximum FROM (SELECT COUNT(id) AS cnt_id  FROM events WHERE osn='$osn' GROUP BY id) AS tbl)) AS temp_tbl WHERE temp_tbl.rte=1 ORDER BY temp_tbl.id ASC LIMIT 1";
    $result = $conn->query($sql);

    if ($result->num_rows > 0) {
        while ($row = $result->fetch_assoc()) {
            $last_rte_id = $row["id"];
            break;
        }
    }

    $sql = "SELECT MAX(id) AS max_id from events WHERE osn='$osn' and rte=0";
    $result = $conn->query($sql);

    if ($result->num_rows > 0) {
        while ($row = $result->fetch_assoc()) {
            $calculated_max_id = $row["max_id"];
            break;
        }
    }

    

    if ($last_rte_id != -1 && $last_rte_id > 0) {
        $last_log_id = min($last_rte_id - 1, $last_log_id);
    }

    $sql = "SELECT * from readers WHERE osn= '$osn' LIMIT 1";
    $result = $conn->query($sql);

    if ($result->num_rows > 0) {
        while ($row = $result->fetch_assoc()) {
            $wl_ts_local = $row["whitelist_on_server"];
            $bl_ts_local = $row["blacklist_on_server"];
            $types_ts_local = $row["types_on_server"];
            $access_rights_ts_local = $row["rights_on_server"];
            $requested_fw = $row["requested_online_firmware"];
            $requested_fw1 = $row["requested_reader1_firmware"];
            $requested_fw2 = $row["requested_reader2_firmware"];
            $current_max_id = $row["max_id"];
            $current_last_id = $row["last_id"];
            $last_valid_id = $row["valid_id"];
            break;
        }
    }

    $sql = "SELECT * from card_types WHERE type <> 1";
    $result = $conn->query($sql);

    if ($result->num_rows > 0) {
        while ($row = $result->fetch_assoc()) {
            $types_color[strval($row["type"])] = $row["color"];
        }
    }

    $sql = "SELECT * from access_rights";
    $result = $conn->query($sql);

    if ($result->num_rows > 0) {
        while ($row = $result->fetch_assoc()) {
            $right = $row["right"];
            $begin_date = strtotime($row["begin_date"]);
            $end_date = strtotime($row["end_date"]);
            $monday_begin = strtotime("01.01.1970 " . $row["monday_begin"]);
            $monday_end = strtotime("01.01.1970 " . $row["monday_end"]);
            $tuesday_begin = strtotime("01.01.1970 " . $row["tuesday_begin"]);
            $tuesday_end = strtotime("01.01.1970 " . $row["tuesday_end"]);
            $wednesday_begin = strtotime("01.01.1970 " . $row["wednesday_begin"]);
            $wednesday_end = strtotime("01.01.1970 " . $row["wednesday_end"]);
            $thursday_begin = strtotime("01.01.1970 " . $row["thursday_begin"]);
            $thursday_end = strtotime("01.01.1970 " . $row["thursday_end"]);
            $friday_begin = strtotime("01.01.1970 " . $row["friday_begin"]);
            $friday_end = strtotime("01.01.1970 " . $row["friday_end"]);
            $saturday_begin = strtotime("01.01.1970 " . $row["saturday_begin"]);
            $saturday_end = strtotime("01.01.1970 " . $row["saturday_end"]);
            $sunday_begin = strtotime("01.01.1970 " . $row["sunday_begin"]);
            $sunday_end = strtotime("01.01.1970 " . $row["sunday_end"]);
            $timeout = $row["timeout"];
            $counter = $row["counter"];

            array_push($available_access_rights, "$right,$begin_date,$end_date,$monday_begin,$monday_end,$tuesday_begin,$tuesday_end,$wednesday_begin,$wednesday_end,$thursday_begin,$thursday_end,$friday_begin,$friday_end,$saturday_begin,$saturday_end,$sunday_begin,$sunday_end,$timeout,$counter
");
        }
    }

    $sql = "SELECT * from users WHERE type <> 1";
    $result = $conn->query($sql);

    if ($result->num_rows > 0) {
        while ($row = $result->fetch_assoc()) {
            if (array_key_exists(strval($row["type"]), $types_color)) {
				$types_list[strval($row["type"])] = "";
                $types_list[strval($row["type"])] .= $row["uid"] . ",";
            }
        }
    }

    $sql = "SELECT * from users WHERE access_right <> 0 AND $osn='ACCESS_RIGHT'";
    $result = $conn->query($sql);

    if ($result->num_rows > 0) {
        while ($row = $result->fetch_assoc()) {
            if (right_is_valid($available_access_rights, strval($row["access_right"]))) {
                $access_rights_list[strval($row["access_right"])] .= $row["uid"] . ",";
            }
        }
    }

    $sql = "SELECT * from users WHERE $osn='WHITELISTED'";
    $result = $conn->query($sql);

    if ($result->num_rows > 0) {
        while ($row = $result->fetch_assoc()) {

            $whitelist .= $row["uid"] . ",";
        }
    }

    $sql = "SELECT * from users WHERE $osn='BLACKLISTED'";
    $result = $conn->query($sql);

    if ($result->num_rows > 0) {
        while ($row = $result->fetch_assoc()) {
            $blacklist .= $row["uid"] . ",";
        }
    }

    if (substr($whitelist, -1, 1) == ',') {
        $whitelist = substr($whitelist, 0, -1);
    }

    if (substr($blacklist, -1, 1) == ',') {
        $blacklist = substr($blacklist, 0, -1);
    }

    foreach ($types_list as $type_key => $type_value) {
        if (substr($type_value, -1, 1) == ',') {
            $type_value = substr($type_value, 0, -1);
        }
    }

    foreach ($access_rights_list as $access_rights_key => $access_rights_value) {
        if (substr($access_rights_value, -1, 1) == ',') {
            $access_rights_value = substr($access_rights_value, 0, -1);
        }
    }

    $wl_ts = date("Y-m-d H:i:s", $wl_ts);
    if($wl_ts == "1970-01-01 00:00:00")
    {
    	$wl_ts = "0000-00-00 00:00:00";
    }

    $sql = "UPDATE readers SET whitelist_in_reader='$wl_ts',whitelist_on_server='$wl_ts_local' WHERE osn='$osn'";

    if (mysqli_query($conn, $sql)) {
    } else {
    }

    $bl_ts = date("Y-m-d H:i:s", $bl_ts);
    if($bl_ts == "1970-01-01 00:00:00")
    {
    	$bl_ts = "0000-00-00 00:00:00";
    }

    $sql = "UPDATE readers SET blacklist_in_reader='$bl_ts',blacklist_on_server='$bl_ts_local' WHERE osn='$osn'";

    if (mysqli_query($conn, $sql)) {
    } else {
    }

    $types_ts = date("Y-m-d H:i:s", $types_ts);
    if($types_ts == "1970-01-01 00:00:00")
    {
    	$types_ts = "0000-00-00 00:00:00";
    }

    $sql = "UPDATE readers SET types_in_reader='$types_ts',types_on_server='$types_ts_local' WHERE osn='$osn'";

    if (mysqli_query($conn, $sql)) {
    } else {
    }

    $access_rights_ts = date("Y-m-d H:i:s", $access_rights_ts);
    if($access_rights_ts == "1970-01-01 00:00:00")
    {
    	$access_rights_ts = "0000-00-00 00:00:00";
    }

    $sql = "UPDATE readers SET rights_in_reader='$access_rights_ts',rights_on_server='$access_rights_ts_local' WHERE osn='$osn'";

    if (mysqli_query($conn, $sql)) {
    } else {
    }

    $date = date_create();
    $timestamp = date_timestamp_get($date);
    $last_seen_ts = date("Y-m-d H:i:s", $timestamp);
    $sql = "UPDATE readers SET ip='$readerIP',online_firmware='$readerFW',reader1_firmware='$readerFW1',reader2_firmware='$readerFW2',last_seen='$last_seen_ts' WHERE osn='$osn'";

    if (mysqli_query($conn, $sql)) {
    } else {
    }

    $sql = "UPDATE readers SET max_id='$calculated_max_id',last_id='$last_log_id' WHERE osn='$osn'";

    if (mysqli_query($conn, $sql)) {
    } else {
    }

    if($current_last_id == $last_log_id && $current_max_id == $calculated_max_id)
    {
        if($last_valid_id == "MAX")
        {
            $last_log_id = $calculated_max_id;
        }
    }
    else
    {
        if($current_max_id != $calculated_max_id)
        {
            $last_log_id = $calculated_max_id;
    
            $sql = "UPDATE readers SET valid_id='MAX' WHERE osn='$osn'";
    
            if (mysqli_query($conn, $sql)) {
            } else {
            }        
        }
        else
        {
            $sql = "UPDATE readers SET valid_id='LAST' WHERE osn='$osn'";
    
            if (mysqli_query($conn, $sql)) {
            } else {
            }  
        }
    }

    $conn->close();

    
  



    if ($wl_ts_local <= $wl_ts) {
        $whitelist = null;
    }

    if ($bl_ts_local <= $bl_ts) {
        $blacklist = null;
    }

    if ($types_ts_local <= $types_ts) {
        $types_output = null;
    }

    if ($access_rights_ts_local <= $access_rights_ts) {
        $access_rights_output = null;
    }

    if ($wl_ts_local > $wl_ts) {
        $whitelist = preg_replace('/\s+/', '', $whitelist);
        $whitelist = "\"" . $whitelist . "\"";
        $whitelist = str_replace(',', "\",\"", $whitelist);
    }

    if ($bl_ts_local > $bl_ts) {
        $blacklist = preg_replace('/\s+/', '', $blacklist);
        $blacklist = "\"" . $blacklist . "\"";
        $blacklist = str_replace(',', "\",\"", $blacklist);
    }

    if ($types_ts_local > $types_ts) {
        $types_output = "\"types\":[";

        foreach ($types_list as $type_key => $type_value) {

            $type_value = preg_replace('/\s+/', '', $type_value);
            $type_value = "\"" . $type_value . "\"";
            $type_value = str_replace(',', "\",\"", $type_value);

            $types_output .= "{\"type\":" . $type_key . "," . "\"color\":" . "\"" . $types_color[$type_key] . "\"" . "," . "\"list\":[" . $type_value . "]" . "}";
            $types_output .= ",";
        }

        $types_output = str_replace(",\"\"", '', $types_output);
        if (count($types_list)) {
            $types_output = substr_replace($types_output, '', strrpos($types_output, ','), 1);
        }

        $types_output .= "]";
    }
    if ($access_rights_ts_local > $access_rights_ts) {
        $access_rights_output = "\"rights\":[";
        foreach ($available_access_rights as $value) {
            $str_arr = explode(",", $value);
            if (array_key_exists($str_arr[0], $access_rights_list)) {
                $access_rights_output .= "{\"right\":" . $str_arr[0];
                $access_rights_output .= ",\"rules\":[";
                $access_rights_output .= strstr($value, $str_arr[1].",");
                $access_rights_output .= "]},";
            }
        }
        if (substr($access_rights_output, -1, 1) == ',') {
            $access_rights_output = substr($access_rights_output, 0, -1);
        }
        $access_rights_output .= "]";

        $access_rights_output_list = "\"rights_uids\":[";

        foreach ($access_rights_list as $right_key => $right_value) {

            $right_value = preg_replace('/\s+/', '', $right_value);
            $right_value = "\"" . $right_value . "\"";
            $right_value = str_replace(',', "\",\"", $right_value);

            $access_rights_output_list .= "{\"right\":" . $right_key . "," . "\"list\":[" . $right_value . "]" . "}";
            $access_rights_output_list .= ",";
        }

   
       
        $access_rights_output_list = str_replace(",\"\"", '', $access_rights_output_list);
        
        if (count($access_rights_list)) {
            $access_rights_output_list = substr_replace($access_rights_output_list, '', strrpos($access_rights_output_list, ','), 1);
        }
     
        $access_rights_output_list .= "]";

        $access_rights_output .= ",".$access_rights_output_list;

    }


    $bl_ts_local = strtotime($bl_ts_local);
    $wl_ts_local = strtotime($wl_ts_local);
    $types_ts_local = strtotime($types_ts_local);
    $access_rights_ts_local = strtotime($access_rights_ts_local);

    if ($requested_fw == null || $requested_fw == $readerFW) {
        $requested_fw = "";
    }

    if ($requested_fw1 == null || $requested_fw1 == $readerFW1) {
        $requested_fw1 = "";
    }

    if ($requested_fw2 == null || $requested_fw2 == $readerFW2) {
        $requested_fw2 = "";
    }

    if ($requested_fw != "" || $requested_fw1 != "" || $requested_fw2 != "") {
        $update_fw = ", \"update_fw\":[\"$requested_fw\", \"$requested_fw1\", \"$requested_fw2\"]";
    } else {
        $update_fw = "";
    }

    if ($whitelist == null && $blacklist == null) {
        $output = "{\"last_id\":$last_log_id, \"time\":$timestamp$update_fw}";
    } else if ($whitelist == null && $blacklist != null) {
        $blacklist = str_replace('""', "", $blacklist);
        $output = "{\"last_id\":$last_log_id, \"time\":$timestamp, \"blacklist\":[$blacklist], \"blacklist_timestamp\":$bl_ts_local$update_fw}";
    } else if ($whitelist != null && $blacklist == null) {
        $whitelist = str_replace('""', "", $whitelist);
        $output = "{\"last_id\":$last_log_id, \"time\":$timestamp, \"whitelist\":[$whitelist], \"whitelist_timestamp\":$wl_ts_local$update_fw}";
    } else {
        $blacklist = str_replace('""', "", $blacklist);
        $whitelist = str_replace('""', "", $whitelist);
        $output = "{\"last_id\":$last_log_id, \"time\":$timestamp, \"blacklist\":[$blacklist], \"blacklist_timestamp\":$bl_ts_local, \"whitelist\":[$whitelist], \"whitelist_timestamp\":$wl_ts_local$update_fw}";
    }

    if ($types_output != null) {
        $output = substr($output, 0, -1);
        $output .= ",";
        $output .= $types_output . ",\"types_timestamp\":" . $types_ts_local;
        $output .= "}";
    }

    if ($access_rights_output != null) {
   
        $output = substr($output, 0, -1);
        $output .= ",";
        $output .= $access_rights_output . ",\"rights_timestamp\":" . $access_rights_ts_local;
        $output .= "}";
     
    }

    echo $output;
    if (DEBUG_LOG) {
        insert_debug_log($output, "FROM_SERVER");
    }
}

function parse_log($log, $rte)
{
    $headers = apache_request_headers();
    $headersUpper = array_change_key_case($headers, CASE_UPPER);
    $osn = $headersUpper["OSN"];
    $sn1 = $headersUpper["SN1"];
    $sn2 = $headersUpper["SN2"];
    global $servername, $username, $password, $dbname, $table;
    $last_id = 0;
    $conn = mysqli_connect($servername, $username, $password, $dbname);

    if (!$conn) {
        die("Connection failed: " . mysqli_connect_error());
    }
    if (!TNA) {
        foreach ($log as $event) {
            $id = $event["id"];
            if($id == null)
            {
            continue;
            }
    
            $uid = $event['uid'];
			if(isset($event['pid']))
			{
				$pid = $event['pid'];
			}
			else
			{
				$pid = null;
			}
            
			$time = $event['time'];
            $delta = $event['delta'];
            $type = $event['type'];
            $status = $event['status'];
            $reader = $event['reader'];
            $note = "";
            $state = 0;
            if(isset($event['state']))
            {
               $state = $event['state'];
            }
    
            if(isset($event['note']))
			{
				$note = $event['note'];
			}
            $sql = "";

            if ($pid == null) {
                $sql = "INSERT INTO $table (id, uid, time, delta, type, state, status, osn, sn1, sn2, reader, rte, note) VALUES ($id,'$uid','$time',$delta,$type,$state,$status,'$osn','$sn1','$sn2', $reader, $rte, '$note') ON DUPLICATE KEY UPDATE rte=$rte";
            } else {
                $sql = "INSERT INTO $table (id, uid, pid, time, delta, type, state, status, osn, sn1, sn2, reader, rte, note) VALUES ($id,'$uid',$pid,'$time',$delta,$type,$state,$status,'$osn','$sn1','$sn2', $reader, $rte, '$note') ON DUPLICATE KEY UPDATE rte=$rte";
            }

            if (mysqli_query($conn, $sql)) {

                $sql = "ALTER TABLE users ADD $osn enum('NOT_LISTED','WHITELISTED','BLACKLISTED','ACCESS_RIGHT') NOT NULL DEFAULT 'NOT_LISTED'";
                try {
                    if (mysqli_query($conn, $sql)) {
                        //file_put_contents("test.txt", "OK");

                    } else {
                        //file_put_contents("test.txt", "Error: " . $sql . "<br>" . mysqli_error($conn));

                    }
                } catch (mysqli_sql_exception $e) {
                }
            } else {
                //file_put_contents("test.txt", "Error: " . $sql . "<br>" . mysqli_error($conn));
                // echo "Error: " . $sql . "<br>" . mysqli_error($conn);

            }
        }
    }

    if (TNA && $rte == 0) {
        $output_array = array();
        foreach ($log as $event) {
            $id = $event["id"];
            if($id == null)
            {
            continue;
            }
    
            $uid = $event['uid'];
            $pid = $event['pid'];
            $time = $event['time'];
            $delta = $event['delta'];
            $type = $event['type'];
            $status = $event['status'];
            $reader = $event['reader'];
            $note = "";
            $state = 0;
            if(isset($event['state']))
            {
               $state = $event['state'];
            }
            if(isset($event['note']))
			{
				$note = $event['note'];
			}
            $sql = "";

            if ($pid == null) {

                $sql = "SELECT pid from users WHERE uid='$uid'";
                $result = $conn->query($sql);

                if ($result->num_rows > 0) {
                    while ($row = $result->fetch_assoc()) {

                        $pid = $row["pid"];
                        break;
                    }
                }
            }

            $item = null;

            if ($pid == null) {
                $item = array(
                    "id" => $id,
                    "uid" => $uid,
                    "time" => $time,
                    "delta" => $delta,
                    "type" => $type,
                    "state" => $state,
                    "status" => $status,
                    "reader" => $reader,
                    "note" => $note
                );
            } else {
                $item = array(
                    "id" => $id,
                    "uid" => $uid,
                    "pid" => $pid,
                    "time" => $time,
                    "delta" => $delta,
                    "type" => $type,
                    "state" => $state,
                    "status" => $status,
                    "reader" => $reader,
                    "note" => $note
                );
            }

            array_push($output_array, $item);
        }

        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, TNA_URL);

        curl_setopt($ch, CURLOPT_POST, 1);

        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($output_array));

        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $headersCurl = array(
            "OSN: $osn",
            "SN1: $sn1",
            "SN2: $sn2",
        );
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headersCurl);
        $server_output = curl_exec($ch);
        $err = curl_error($ch);
        curl_close($ch);

        if ($err) {
            //echo "Error: Proxy error #" . $err;



        }

        if ($server_output == "OK") {
            foreach ($log as $event) {
                $id = $event["id"];
                if($id == null)
                {
                continue;
                }
        
                $uid = $event['uid'];
                $pid = $event['pid'];
                $time = $event['time'];
                $delta = $event['delta'];
                $type = $event['type'];
                $status = $event['status'];
                $reader = $event['reader'];
                $note = "";
                $state = 0;
                if(isset($event['state']))
                {
                    $state = $event['state'];
                }
                if(isset($event['note']))
			    {
				    $note = $event['note'];
			    }
                $sql = "";
                if ($pid == null) {
                    $sql = "INSERT INTO events (id, uid, time, delta, type, state, status, osn, sn1, sn2, reader, rte, note) VALUES ($id,'$uid','$time',$delta,$type,$state,$status,'$osn','$sn1','$sn2', $reader, $rte, '$note') ON DUPLICATE KEY UPDATE rte=$rte";
                } else {
                    $sql = "INSERT INTO events (id, uid, pid, time, delta, type, state, status, osn, sn1, sn2, reader, rte, note) VALUES ($id,'$uid', $pid, '$time',$delta,$type,$state,$status,'$osn','$sn1','$sn2', $reader, $rte, '$note') ON DUPLICATE KEY UPDATE rte=$rte";
                }
                if (mysqli_query($conn, $sql)) {
                    $sql = "ALTER TABLE users ADD $osn enum('NOT_LISTED','WHITELISTED','BLACKLISTED','ACCESS_RIGHT') NOT NULL DEFAULT 'NOT_LISTED'";
                    try {
                        if (mysqli_query($conn, $sql)) {
                            //file_put_contents("test.txt", "OK");

                        } else {
                            //file_put_contents("test.txt", "Error: " . $sql . "<br>" . mysqli_error($conn));

                        }
                    } catch (mysqli_sql_exception $e) {
                    }
                } else {
                    //file_put_contents("test.txt", "Error: " . $sql . "<br>" . mysqli_error($conn));
                    // echo "Error: " . $sql . "<br>" . mysqli_error($conn);

                }
            }
        }
    }

    mysqli_close($conn);
}

function read_log($osn)
{
    global $servername, $username, $password, $dbname;
    $last_id = 0;
    $conn = mysqli_connect($servername, $username, $password, $dbname);

    if (!$conn) {
        die("Connection failed: " . mysqli_connect_error());
    }
    echo "<style>body{background:#fafafa}.styled-table{border-collapse:collapse;margin:25px 0;font-size:.9em;font-family:sans-serif;width:100%;box-shadow:0 0 20px rgba(0,0,0,.15)}.styled-table thead tr{background-color:#8ec73d;color:#fff;text-align:left}.styled-table td,.styled-table th{padding:12px 15px}.styled-table tbody tr{border-bottom:1px solid #ddd}.styled-table tbody tr:nth-of-type(even){background-color:#f3f3f3}.styled-table tbody tr:last-of-type{border-bottom:2px solid #8ec73d}.styled-table tbody tr.active-row{font-weight:700;color:#8ec73d}.formbold-main-wrapper{display:flex;align-items:center;justify-content:center;padding:48px}.formbold-form-wrapper{margin:0 auto;width:100%;background:#fafafa}.formbold-img{display:flex;align-items:center;justify-content:center;padding:48px}</style>";
    echo '<div class="formbold-main-wrapper"><div class="formbold-form-wrapper"><table class="styled-table"><thead> 
      <tr> 
          <th>ID</th> 
          <th>UID</th> 
          <th>PID</th> 
          <th>UTC TIME</th> 
          <th>DELTA TIME</th> 
          <th>TYPE</th> 
          <th>STATE</th> 
          <th>STATUS</th> 
          <th>ONLINE SN</th> 
          <th>UFR SN</th>
          <th>NOTE</th> 
      </tr></thead><tbody>';

    $sql = "SELECT * from events WHERE osn='$osn' ORDER BY id DESC";
    $result = $conn->query($sql);

    if ($result->num_rows > 0) {
        while ($row = $result->fetch_assoc()) {
            $sn = "";
            if ($row["reader"] == 1) {
                $sn = $row["sn1"];
            } else {
                $sn = $row["sn2"];
            }
            if ($row["rte"] == 1) {
                echo '<tr style="background-color:#DA721B">';
            } else {
                echo '<tr>';
            }

            echo '<td>' . $row["id"] . '</td> 
        <td>' . $row["uid"] . '</td> 
        <td>' . $row["pid"] . '</td> 
        <td>' . $row["time"] . '</td> 
        <td>' . $row["delta"] . '</td> 
        <td>' . $row["type"] . '</td> 
        <td>' . $row["state"] . '</td> 
        <td>' . $row["status"] . '</td> 
        <td>' . $row["osn"] . '</td> 
        <td>' . $sn . '</td> 
        <td>' . $row["note"] . '</td> 
    </tr>';
        }
    }
    echo "</tbody></table></div></div>";
    $conn->close();
}

function insert_debug_log($post, $direction)
{
    $headers = apache_request_headers();
    $headersUpper = array_change_key_case($headers, CASE_UPPER);
    $osn = $headersUpper["OSN"];
    global $servername, $username, $password, $dbname, $table;
    $conn = mysqli_connect($servername, $username, $password, $dbname);

    if (!$conn) {
        die("Connection failed: " . mysqli_connect_error());
    }

    $sql = "INSERT INTO debug_log (log, osn, direction) VALUES ('$post', '$osn', '$direction')";

    if (mysqli_query($conn, $sql)) {
        //echo OK;

    } else {
        // echo "Error: " . $sql . "<br>" . mysqli_error($conn);

    }
}